routes/web.php
<?php

use App\Http\Controllers\AccountController;
use App\Http\Controllers\AdController;
use App\Http\Controllers\Api\AuthController;
use App\Http\Controllers\ContractController;
use App\Http\Controllers\MailController;
use App\Http\Controllers\PropertyController;
use App\Http\Controllers\SubscriptionController;
use App\Http\Controllers\ChartJSController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\WalletController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

//Route::get('/', function () {
//    return view('home.home');
//});

//Route::get('/index', function () {
//    return view('users.index');
//});

Route::get('/charts', [ChartJSController::class, 'index'])->name('charts.index');

Route::get('/sendCode', [MailController::class, 'index']);

Route::get('/login', [AuthController::class, 'login']);

Route::view('/', 'Auth.auth')->name('auth');


//Auth::routes();
Route::get('/home', [AccountController::class, 'showAll'])->name('home');


//Route::group(['middleware' => ['auth:web', 'isActive']], function () {

Route::group(['prefix' => 'accounts'], function () {
    Route::get('/', [AccountController::class, 'showAll'])->name('accounts.index');
    Route::get('/create', [AccountController::class, 'create'])->name('accounts.create');
    Route::post('/createAccount', [AuthController::class, 'createAccount'])->name('accounts.store');
    Route::get('/{account_id}/show', [AccountController::class, 'showAccount'])->name('accounts.show');
    Route::get('/{account_id}/edit', [AccountController::class, 'edit'])->name('accounts.edit');
    Route::post('/update', [AccountController::class, 'update'])->name('accounts.update');
    Route::delete('/delete/{account_id}', [AccountController::class, 'destroy'])->name('accounts.destroy');
    Route::get('/search', [AccountController::class, 'search'])->name('accounts.search');
    Route::post('/blocked', [AccountController::class, 'accountBlock'])->name('accounts.blocked');
});

Route::prefix('ads/')->group(function () {
    Route::get('index', [AdController::class, 'showAll'])->name('ads.index');
    Route::post('create', [AdController::class, 'store'])->name('ads.store');
    Route::view('create','ads.create')->name('ads.create');
    Route::post('update/{ad_id}', [AdController::class, 'update'])->name('ads.update');
    Route::get('show/{ad_id}', [AdController::class, 'showAd'])->name('ads.show');
    Route::get('editAd/{ad_id}', [AdController::class, 'editAd'])->name('ads.edit');
    Route::delete('delete/{ad_id}', [AdController::class, 'destroy'])->name('ads.delete');
    Route::post('uploadImg/{ad_id}', [AdController::class, 'uploadImg'])->name('ads.uploadImg');
});

Route::prefix('orders/')->group(function () {
    Route::get('showAllOrdersProperty', [PropertyController::class, 'showAllOrdersProperty'])->name('orders.index');
    Route::post('acceptRefuse', [PropertyController::class, 'acceptRefuse'])->name('orders.acceptRefuse');
    Route::get('show/{property_id}', [PropertyController::class, 'showProperty'])->name('orders.showProperty');

    Route::get('showAllOrdersContract', [ContractController::class, 'showAllOrdersContract'])->name('ordersContract.index');
    Route::post('acceptRefuseContract', [ContractController::class, 'acceptRefuse'])->name('ordersContract.acceptRefuse');
    Route::get('showContract/{contract_id}', [ContractController::class, 'showContract'])->name('ordersContract.showContract');
});


Route::prefix('subscriptions/')->name('subscriptions.')->group(function () {
    Route::get('index', [SubscriptionController::class, 'showAll'])->name('index');
    Route::view('create','subscriptions.create')->name('create');
    Route::post('create', [SubscriptionController::class, 'create'])->name('store');
    Route::delete('delete/{subscription_id}', [SubscriptionController::class, 'destroy'])->name('destroy');
    Route::get('show/{subscription_id}', [SubscriptionController::class, 'show'])->name('show');
    Route::post('update/{subscription_id}', [SubscriptionController::class, 'update'])->name('update');
    Route::get('edit/{subscription_id}', [SubscriptionController::class, 'edit'])->name('edit');
});


Route::prefix('wallets/')->name('wallets.')->group(function (){
    Route::get('index',[WalletController::class,'index'])->name('index');
    Route::post('chargeWallet',[WalletController::class,'chargeWallet'])->name('chargeWallet');
    Route::post('create',[WalletController::class,'create'])->name('create');
    Route::get('show/{wallet_id}',[WalletController::class,'show'])->name('show');
    Route::get('edit/{wallet_id}',[WalletController::class,'edit'])->name('edit');
    Route::delete('delete/{wallet_id}',[WalletController::class,'destroy'])->name('destroy');
});

//});

app/Models/Subscription.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Subscription extends Model
{
    use HasFactory;

    protected $table = 'subscriptions';

    protected $primaryKey = 'id';

    public $timestamps = false;

    protected $fillable = [
        'name',
        'price',
        'propertyNumber',
        'period'
    ];

    public function users()
    {
        return $this->belongsToMany(User::class, 'sub_records', 'subscription_id', 'user_id')->withPivot('date');
    }
}

app/Http/Controllers/SubscriptionController.php
<?php

namespace App\Http\Controllers;

use App\Models\SubRecord;
use App\Models\Subscription;
use App\Models\User;
use App\Models\Wallet;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;
use Illuminate\Support\Facades\Auth;
use function PHPUnit\Framework\isEmpty;

class SubscriptionController extends Controller
{

    // public function subscribe(Request $request)
    // {
    //     $user = User::where('account_id', Auth::id())->first();
    //     if (isset($user) == 0) {
    //         return response()->json([
    //             'Status' => 'Failed',
    //             'Message' => 'User not found',
    //             'List' => null,
    //             'Code' => Response::HTTP_NOT_ACCEPTABLE,
    //         ]);
    //     }
    //     $subscription = Subscription::find($request->subscription_id);
    //     if (isset($subscription) == 0) {
    //         return response()->json([
    //             'Status' => 'Failed',
    //             'Message' => 'Subscription not found',
    //             'List' => null,
    //             'Code' => Response::HTTP_NOT_ACCEPTABLE,
    //         ]);
    //     }
    //     $subRecord = SubRecord::where('user_id', $user->id)->latest()->first();
    //     if (isset($subRecord) == 1) {
    //         if ($subRecord->date >= Carbon::now()->format('Y-m-d')) {
    //             return response()->json([
    //                 'Status' => 'Failed',
    //                 'Message' => 'You are already subscribed',
    //                 'List' => null,
    //                 'Code' => Response::HTTP_NOT_ACCEPTABLE,
    //             ]);
    //         }
    //     }
    //     $wallet = Wallet::where('user_id', $user->id)->first();
    //     if ($wallet) {
    //         $value = $wallet->amount - $subscription->price;
    //         if ($value >= 0) {
    //             $wallet->update([
    //                 'amount' => $value
    //             ]);
    //             $subscription = SubRecord::create([
    //                 'subscription_id' => $request->subscription_id,
    //                 'date' => Carbon::now()->addDays((int)$subscription->period)->format('Y-m-d'),
    //                 'user_id' => $user->id
    //             ]);
    //             return response()->json([
    //                 'Status' => 'Success',
    //                 'Message' => 'Subscription completed successfully',
    //                 'List' => $subscription,
    //                 'Code' => Response::HTTP_OK,
    //             ]);
    //         }
    //         return response()->json([
    //             'Status' => 'Failed',
    //             'Message' => 'The amount in your wallet is not enough to pay the subscription cost',
    //             'subscription' => $subscription,
    //             'wallet' => $wallet,
    //             'Code' => Response::HTTP_NOT_ACCEPTABLE,
    //         ]);
    //     }
    //     return response()->json([
    //         'Status' => 'Failed',
    //         'Message' => 'The amount in your wallet is not enough to pay the subscription cost',
    //         'List' => null,
    //         'Code' => Response::HTTP_NOT_ACCEPTABLE,
    //     ]);
    // }
    
    
    
    public function showMySub()
    {
        $user = User::where('account_id', Auth::id())->first();
        $subRecord = SubRecord::where('user_id', $user->id)->orderBy('id', 'desc')->first();
        if (!$subRecord) {
            return response()->json([
                'Status' => 'Failed',
                'Message' => 'You Are not Subscribe Yet',
                'List' => null,
                'Code' => Response::HTTP_NOT_ACCEPTABLE,
            ]);
        }
        $subRecord->makeHidden(['created_at', 'updated_at', 'id', 'user_id', 'subscription_id']);
        if ($subRecord->date >= Carbon::now()->format('Y-m-d')) {
            return response()->json([
                'Status' => 'Success',
                'Message' => 'Your Subscription',
                'List' => $subRecord,
                'Code' => Response::HTTP_OK,
            ]);
        } else {
            return response()->json([
                'Status' => 'Failed',
                'Message' => 'Your subscription has expired.',
                'List' => null,
                'Code' => Response::HTTP_NOT_ACCEPTABLE,
            ]);
        }
    }
    
    public function subscribe(Request $request)
    {
        $user = User::where('account_id', Auth::id())->first();
        if (isset($user) == 0) {
            return response()->json([
                'Status' => 'Failed',
                'Message' => 'User not found',
                'List' => null,
                'Code' => Response::HTTP_NOT_ACCEPTABLE,
            ]);
        }
        $subscription = Subscription::find($request->subscription_id);
        if (isset($subscription) == 0) {
            return response()->json([
                'Status' => 'Failed',
                'Message' => 'Subscription not found',
                'List' => null,
                'Code' => Response::HTTP_NOT_ACCEPTABLE,
            ]);
        }
        $subRecord = SubRecord::where('user_id', $user->id)->orderBy('id', 'desc')->first();
        if (isset($subRecord) == 1) {
            if ($subRecord->date >= Carbon::now()->format('Y-m-d')) {
                return response()->json([
                    'Status' => 'Failed',
                    'Message' => 'You are already subscribed',
                    'List' => null,
                    'Code' => Response::HTTP_NOT_ACCEPTABLE,
                ]);
            }
        }
        $wallet = Wallet::where('user_id', $user->id)->first();
        if ($wallet) {
            $value = $wallet->amount - $subscription->price;
            if ($value >= 0) {
                $wallet->update([
                    'amount' => $value
                ]);
                $subscription = SubRecord::create([
                    'subscription_id' => $request->subscription_id,
                    'date' => Carbon::now()->addDays((int)$subscription->period)->format('Y-m-d'),
                    'remainingProperty' => $subscription->propertyNumber,
                    'user_id' => $user->id
                ]);
                return response()->json([
                    'Status' => 'Success',
                    'Message' => 'Subscription completed successfully',
                    'List' => $subscription,
                    'Code' => Response::HTTP_OK,
                ]);
            }
            return response()->json([
                'Status' => 'Failed',
                'Message' => 'The amount in your wallet is not enough to pay the subscription cost',
                'List' => null,
                'Code' => Response::HTTP_NOT_ACCEPTABLE,
            ]);
        }
        return response()->json([
            'Status' => 'Failed',
            'Message' => 'The amount in your wallet is not enough to pay the subscription cost',
            'List' => null,
            'Code' => Response::HTTP_NOT_ACCEPTABLE,
        ]);
    }


    public function showAllSubRecord()
    {
        $user = User::where('account_id', Auth::id())->first();
        $subRecord = $user->subscriptions()->get();

        $subRecord->transform(function ($item) {
            return [
                'name' => $item->name,
                'period' => $item->period,
                'end in' => $item->pivot->date,
            ];
        });

        if ($subRecord->isEmpty()) {
            return response()->json([
                'Status' => 'Failed',
                'Message' => 'You are not subscribed in the app before',
                'List' => null,
                'Code' => Response::HTTP_NOT_ACCEPTABLE,
            ]);
        }

        return response()->json([
            'Status' => 'Success',
            'Message' => 'All previous subscriptions',
            'List' => $subRecord,
            'Code' => Response::HTTP_OK,
        ]);
    }



    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $subscriptions = Subscription::all();
        if (isset($subscriptions[0]) == 1) {
            $subscriptions->makeHidden(['created_at', 'updated_at']);
            return response()->json([
                'Status' => 'Success',
                'Message' => 'All Subscriptions',
                'List' => $subscriptions,
                'Code' => Response::HTTP_OK,
            ]);
        }
        return response()->json([
            'Status' => 'Failed',
            'Message' => 'There are no Subscriptions',
            'List' => null,
            'Code' => Response::HTTP_NOT_ACCEPTABLE,
        ]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create(Request $request)
    {
        Subscription::create([
            'price' => $request->price,
            'name' => $request->name,
            'period' => $request->period,
            'propertyNumber' => $request->propertyNumber
        ]);

        return redirect()->route('subscriptions.index');

    }

    /**
     * Display the specified resource.
     */
    public function show($subscription_id)
    {
        $subscription = Subscription::find($subscription_id);

        if (isset($subscription)) {
            $subscription->makeHidden(['created_at', 'updated_at']);
        }

        return view('subscriptions.show',['subscription'=>$subscription]);

    }

    /**
     * Show the form for editing the specified resource.
     */
    public function update(Subscription $subscription, $subscription_id, Request $request)
    {
        $subscription = Subscription::find($subscription_id);

        if (isset($subscription)) {

            $subscription->update($request->all());

        }

        return redirect()->route('subscriptions.index');

    }

    /**
     * Remove the specified resource from storage.
     */

resources/views/subscriptions/create.blade.php
@extends('home.home')

@section('content')
    <div class="bg-light p-4 rounded" style="height: 700px">
        <h1>Add New Subscription</h1>
        <div class="container mt-4">


            <div class="row">
                <div class="col-4 d-flex justify-content-center">
                </div>


                <div class="col-4 d-flex justify-content-center">
                    <form method="POST" action="{{ route('subscriptions.store') }}">
                        @csrf
                        <div class="mb-3">
                            <label for="name" class="form-label">Name</label>
                            <input type="text" class="form-control" name="name" placeholder="Name" required>
                        </div>
                        <div class="mb-3">
                            <label for="price" class="form-label">Price</label>
                            <input type="number" class="form-control" name="price" placeholder="Price" required>
                        </div>
                        <div class="mb-3">
                            <label for="period" class="form-label">Period Of Subscription</label>
                            <input type="number" class="form-control" name="period" placeholder="Period ( by days )" required>
                        </div>

                        <div class="mb-3">
                            <label for="propertyNumber" class="form-label">Property Number</label>
                            <input type="number" class="form-control" name="propertyNumber" placeholder="Property Number"
                                   required>
                        </div>

                        <div class="d-flex justify-content-center">
                            <button type="submit" class="btn btn-primary mb-3">Create subscription</button>
                        </div>
                    </form>
                </div>


                <div class="col-4 d-flex justify-content-center">
                </div>
                <div class="d-flex justify-content-center mt-5">
                    <a href="{{ route('subscriptions.index') }}" class="btn btn-primary">Back</a>
                </div>

            </div>

        </div>
@endsection
        @section('scripts')
            <script>
                $('.subscriptions').addClass("btnFocused");

            </script>
@endsection

resources/views/subscriptions/edit.blade.php
@extends('home.home')

@section('content')
    <div class="bg-light p-4 rounded" style=" height: 700px;">
        <h1>Update Subscription</h1>
        <div class="lead">

        </div>

        <div class="container mt-4">

            <div class="row">
                    <div class="col-4 d-flex justify-content-center">
                    </div>

                    <div class="col-4 d-flex justify-content-center">
                        <form method="POST" action="{{ route('subscriptions.update', $subscription->id) }}">
                            @csrf
                            <div class="mb-3">
                                <label for="name" class="form-label">Name</label>
                                <input type="text" class="form-control" name="name" placeholder="Name"
                                       value="{{ $subscription->name}}" required>
                            </div>
                            <div class="mb-3">
                                <label for="price" class="form-label">price</label>
                                <input type="number" class="form-control" name="price" placeholder="price"
                                       value="{{ $subscription->price}}" required>
                            </div>
                            <div class="mb-3">
                                <label for="period" class="form-label">Period ( By Days )</label>
                                <input type="number" class="form-control" name="period" placeholder="Period"
                                       value="{{ $subscription->period}}" required>
                            </div>

                            <div class="mb-3">
                                <label for="propertyNumber" class="form-label">Property Number</label>
                                <input type="number" class="form-control" name="propertyNumber" placeholder="Property Number"
                                       value="{{ $subscription->propertyNumber}}" required>
                            </div>

                            <div class="d-flex justify-content-center">
                                <button type="submit" class="btn btn-primary mb-3">Update subscription</button>
                            </div>
                        </form>
                    </div>

                    <div class="col-4 d-flex justify-content-center">
                    </div>
                <div class="d-flex justify-content-center mt-5">
                    <a href="{{ route('subscriptions.index') }}" class="btn btn-primary">Back</a>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('scripts')
    <script>
        $('.subscriptions').addClass("btnFocused");
    </script>
@endsection

resources/views/subscriptions/index.blade.php
@extends('home.home')

@section('content')

    <h1 class="mb- text-center">Subscription Management</h1>

    <div class="bg-light p-4 rounded">

        <div class="row justify-content-end">
            <div class="col-11">
                <h1>Subscriptions</h1>
            </div>
            <div class="col-1">
                <a href="{{ route('subscriptions.create') }}" class="btn btn-primary btn-sm float-right"
                   style="margin: 0px;">Add New Subscription</a>
            </div>
        </div>

        <div style=" height: 100% !important;
            width: auto !important;
            overflow: auto !important;">
            <table class="table table-striped" id="myTable" style="">
                <thead>
                <tr>
                    <th scope="col" width="1%">ID</th>
                    <th scope="col" width="10%">Name</th>
                    <th scope="col" width="10%">Price</th>
                    <th scope="col" width="10%">Property Number</th>
                    <th scope="col" width="10%">Period</th>
                    <th scope="col" width="10%" colspan="3">Action</th>
                </tr>
                </thead>
                <tbody>
                @foreach($subscriptions as $subscription)
                    <tr>
                        <th scope="row">{{ $subscription->id }}</th>
                        <td> {{ $subscription->name}}</td>
                        <td><span class="badge rounded-pill bg-primary">{{ $subscription->price }}  SP</span></td>
                        <td><span class="badge rounded-pill bg-primary">{{ $subscription->propertyNumber}}  Properties</span></td>
                        <td><span class="badge rounded-pill bg-primary">{{ $subscription->period }}  Days</span></td>
                        <td>
                            <a href="{{ route('subscriptions.show', $subscription->id) }}" class="btn btn-warning btn-sm">Show</a>
                            <a href="{{ route('subscriptions.edit', $subscription->id) }}" class="btn btn-info btn-sm">Edit</a>
                            {!! Form::open(['method' => 'DELETE','route' => ['subscriptions.destroy', $subscription->id],'style'=>'display:inline']) !!}
                            {!! Form::submit('Delete', ['class' => 'btn btn-danger btn-sm']) !!}
                            {!! Form::close() !!}
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>

            @if(!isset($paginate))
                <div class="d-flex justify-content-center">
                    {!! $subscriptions->links() !!}
                </div>
            @endif

        </div>
    </div>

@endsection

@section('scripts')
    <script>
        $.ajaxSetup({
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
            }
        });
    </script>
    <script>
        $('.subscriptions').addClass("btnFocused");
    </script>
@endsection

resources/views/subscriptions/show.blade.php
@extends('home.home')

@section('content')
    <div class="bg-light p-5 rounded">
        <h1>Show Subscription</h1>

        <div class="container mt-4">
            <div style="font-size: large;">
                <span style="font-weight: bold;">Name  :  </span><span class="badge rounded-pill bg-primary">{{ $subscription->name}}</span>

            </div>
            <div style="font-size: large;">
                <span style="font-weight: bold;">Price :  </span><span class="badge rounded-pill bg-primary">{{ $subscription->price }}</span> SP
            </div>
            <div style="font-size: large;">
                <span style="font-weight: bold;">Period :  </span><span class="badge rounded-pill bg-primary">{{ $subscription->period }}</span> Days
            </div>
            <div style="font-size: large;">
                <span style="font-weight: bold;">Property Number  :  </span><span class="badge rounded-pill bg-primary">{{ $subscription->propertyNumber }}</span> Properties
            </div>
            <div class="d-flex justify-content-center mt-5">
                <a href="{{ route('subscriptions.index') }}" class="btn btn-primary">Back</a>
            </div>
        </div>
    </div>

@endsection
@section('scripts')
    <script>
        $('.subscriptions').addClass("btnFocused");
    </script>
@endsection